package com.lynn;

import com.alibaba.fastjson.JSON;
import com.grapecity.documents.excel.*;
import com.grapecity.documents.excel.drawing.*;
// import com.grapecity.documents.excel.template.DataSource.JsonDataSource;
import com.sun.corba.se.spi.orbutil.threadpool.Work;
import com.sun.scenario.effect.impl.sw.sse.SSEBlend_SRC_OUTPeer;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.pdfbox.io.IOUtils;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.PDPage;
import org.apache.pdfbox.pdmodel.PDPageContentStream;
import org.apache.pdfbox.pdmodel.common.PDRectangle;
import org.apache.pdfbox.pdmodel.font.PDFont;
import org.apache.pdfbox.pdmodel.font.PDType0Font;
import org.apache.pdfbox.pdmodel.graphics.image.PDImageXObject;
import org.apache.pdfbox.rendering.PDFRenderer;
import com.google.gson.JsonObject;

/*import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;*/
import java.io.*;
import java.util.*;
import java.net.*;
import java.time.*;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.util.List;

import com.google.common.collect.Lists;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

public class Test {

    public static void main(String[] args) throws Exception {
        Workbook workbook = new Workbook();
        //windows下请注释此句代码
        //Workbook.FontsFolderPath = "fonts";
        workbook.open("数据 (2).ssjson");

        IShapes shapes = workbook.getWorksheets().get("封面页").getShapes();
        //获取封面页图片
        byte[] pic = shapes.get(1).getPictureFormat().getFill();
        String code = shapes.get(2).getTextFrame().getTextRange().getText();
        String time = shapes.get(3).getTextFrame().getTextRange().getText();
        //log.info(workbook.getWorksheets().getCount()+"  个sheets");

        for (int i = 0;i<workbook.getWorksheets().getCount();i++){
            IWorksheet worksheet = workbook.getWorksheets().get(i);

            if (worksheet.getName().equals("指数"))continue;
            if (worksheet.getName().equals("数据"))continue;
            worksheet.getPageSetup().setPaperSize(PaperSize.A4);
            JSONObject object = JSON.parseObject(worksheet.getPageSetup().toJson());
            //log.info(worksheet.getPageSetup().toJson());
            object.remove("firstPageNumber");
            String json  = JSON.toJSONString(object);
            //log.info(json);
            worksheet.getPageSetup().fromJson(json);

            if (worksheet.getName().equals("封面页")){
                worksheet.getPageSetup().setTopMargin(0);
                worksheet.getPageSetup().setLeftMargin(0);
                worksheet.getPageSetup().setRightMargin(0);
                worksheet.getPageSetup().setBottomMargin(0);
                worksheet.getPageSetup().setIsPercentScale(false);
                worksheet.getPageSetup().setFitToPagesWide(1);
                continue;
            }
            worksheet.getPageSetup().setTopMargin(70);
            worksheet.getPageSetup().setLeftMargin(0);
            worksheet.getPageSetup().setRightMargin(0);
            worksheet.getPageSetup().setCenterHorizontally(true);
            //worksheet.getPageSetup().setCenterHeader("\n\n"+excel.getReportName());
            worksheet.getPageSetup().setCenterHeader("\n\n" + "ABCD123456789");

            worksheet.getPageSetup().setLeftHeader("        &G");
            worksheet.getPageSetup().setHeaderMargin(15);
            worksheet.getPageSetup().getLeftHeaderPicture().setFilename("pdf-up.png");
            worksheet.getPageSetup().getLeftHeaderPicture().setWidth(150);
            worksheet.getPageSetup().getLeftHeaderPicture().setHeight(35.9);
            worksheet.getPageSetup().setAlignMarginsHeaderFooter(true);
//            worksheet.getPageSetup().setFirstPageNumber(null);
            worksheet.getPageSetup().setCenterFooter("&P/&N");
            worksheet.getPageSetup().setDifferentFirstPageHeaderFooter(true);

//            worksheet.getPageSetup().setDifferentFirstPageHeaderFooter(true);

            //为详情页增加打印分页符
            if (!worksheet.getName().equals("列表页-新增")&&!worksheet.getName().equals("列表页-更新")){
                worksheet.getHPageBreaks().add(worksheet.getRange("F44"));

            }
            if (worksheet.getName().equals("列表页-新增")){
                int hc = worksheet.getHPageBreaks().getCount();
                for(int h = hc-1; h >= 0; h--) {
                    worksheet.getHPageBreaks().get(h).delete();
                }
                IRange usedRange_style = worksheet.getUsedRange(EnumSet.of(UsedRangeType.Style));
                int cellcount = usedRange_style.getCount();
                int rowNum = cellcount/44;
                for (int ll=1;ll<rowNum+1;ll++){
                    String str = "F"+ll*44;
                    //log.error("create:"+str);
                    worksheet.getHPageBreaks().add(worksheet.getRange(str));
                }
            }
            if (worksheet.getName().equals("列表页-更新")){
                int hc = worksheet.getHPageBreaks().getCount();
                for(int h = hc-1; h >= 0; h--) {
                    worksheet.getHPageBreaks().get(h).delete();
                }
                IRange usedRange_style = worksheet.getUsedRange(EnumSet.of(UsedRangeType.Style));
                int cellcount = usedRange_style.getCount();
                int rowNum = cellcount/44;
                for (int ll=1;ll<rowNum+1;ll++){
                    String str = "F"+ll*44;
                    //log.error("update:"+str);
                    worksheet.getHPageBreaks().add(worksheet.getRange(str));
                }
            }
        }

        try {
            //删除封面页
            workbook.getWorksheets().get(0).delete();

            ByteArrayOutputStream output = new ByteArrayOutputStream();
            PdfSaveOptions options = new PdfSaveOptions();
            /*MqttClient mqttClient = mqttMessageService.openMqttClent(topic);
            options.getPagePrintingEvent().addListener((sender, e) -> {
                try {
                    sendPdfPrintProcess(e,topic,mqttClient);
                } catch (MqttException ex) {
                    ex.printStackTrace();
                    log.error(ex.getMessage());
                }
            });*/
            workbook.save(output,options);
            output.close();
            ByteArrayInputStream input = new ByteArrayInputStream(output.toByteArray());
            PDDocument document = PDDocument.load(input);
            input.close();
            //File file2 = new File(ruoyiConfig.getTtfFilePath()+"simkai.ttf");
            File file2 = new File("fonts\\simkai.ttf");

            PDFont font = PDType0Font.load(document,file2);
            PDPage page = document.getPage(0);
            PDRectangle pageSize = page.getMediaBox();
            float pageWidth = pageSize.getWidth();
            float pageHeight = pageSize.getHeight();
            PDPage firstPage = new PDPage(new PDRectangle(pageWidth, pageHeight));
            PDPageContentStream contentStream = new PDPageContentStream(document, firstPage, PDPageContentStream.AppendMode.APPEND, true, true);
            PDImageXObject image = PDImageXObject.createFromByteArray(document, pic, null);
            contentStream.drawImage(image, 0, 0, pageWidth, pageHeight);
            contentStream.beginText();
            //设置要显示的文本的颜色
            contentStream.setNonStrokingColor(java.awt.Color.white);
            contentStream.setFont(font, 16);
            contentStream.newLineAtOffset(78,200);
            contentStream.showText(code);
            contentStream.endText();
            contentStream.beginText();
            //设置要显示的文本的颜色
            contentStream.setNonStrokingColor(java.awt.Color.white);
            contentStream.setFont(font, 16);
            contentStream.newLineAtOffset(78,170);
            contentStream.showText(time);
            contentStream.endText();

            document.getPages().insertBefore(firstPage, page);
            contentStream.close();
            /*String filename = topic+"_"+excel.getReportName()+".pdf";
            File file = new File(RuoYiConfig.getDownloadPath()+filename);
            if (!file.getParentFile().exists())
            {
                file.getParentFile().mkdirs();
            }*/
            document.save("229.pdf");
            //document.save("229_linux.pdf");
            document.close();
            //sendPdfPrintOver(topic,mqttClient,filename);
        }/* catch (IOException | MqttException e) {
            throw new RuntimeException(e);
        }*/
        catch (IOException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            e.printStackTrace();
            //log.error(e.getMessage());
        }















//        Workbook workbook = new Workbook();
//        workbook.open("enter.ssjson");
//        workbook.save("enter_after.pdf");


        /*Workbook workbook = new Workbook();
        workbook.open("导入excel查询前图表正常.json");
        // 导出json
        // export json
        String exportJsonStr = workbook.toJson();
        FileWriter writer;
        try {
            writer = new FileWriter("导入excel查询前图表正常_after.ssjson");
            writer.write("");
            writer.write(exportJsonStr);
            writer.flush();
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
        }*/


     /*   XlsxOpenOptions options = new XlsxOpenOptions();
        options.setDoNotRecalculateAfterOpened(true);
        workbook.open("lx98.xlsx", options);
        IWorksheet worksheet = workbook.getActiveSheet();
        System.out.println(worksheet.getRange("B8").getValue());*/




        //workbook.setCulture(Locale.CHINA);

         /*workbook.open("test94_update.xlsx");
        IWorksheet worksheet1 = workbook.getWorksheets().get(2);
        IComment comment1 = worksheet1.getComments().get(0);
        IRange range1 = comment1.getAnchorCell();
        String str1 = comment1.getText();
        // 删除原有comment，重新生成
        range1.getComment().delete();
        range1.addComment(str1);


        IWorksheet worksheet2 = workbook.getWorksheets().get(3);
        IComment comment2 = worksheet2.getComments().get(0);
        IRange range2 = comment2.getAnchorCell();
        String str2 = comment2.getText();
        // 删除原有comment，重新生成
        comment2.delete();
        range2.addComment(str2);

        // 导出excel文件
        workbook.save("test94_update_after.xlsx");*/




        /*workbook.save("after829.xlsx");
        // export json
        String exportJsonStr = workbook.toJson();
        FileWriter writer;
        try {
            writer = new FileWriter("after829.ssjson");
            writer.write("");
            writer.write(exportJsonStr);
            writer.flush();
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
        }*/


       /* workbook.open("cysx_818.ssjson");
        byte[] pic = workbook.getWorksheets().get("封面页").getShapes().get("Picture 1").getPictureFormat().getFill();
        // 方案1：直接对原workbook删除或隐藏原封面页，使不被导出
        // workbook.getWorksheets().get(0).delete();

        // 方案2：对new出来的新workbook做导出pdf操作，避免对原workbook产生影响。
        Workbook workbook1 = new Workbook();
        workbook1.fromJson(workbook.toJson());
        workbook1.getWorksheets().get(0).delete();
        workbook1.save("exportJava_before.pdf");

        try {
            PDDocument document = PDDocument.load(new File("exportJava_before.pdf"));
            PDPage page = document.getPage(0);
            PDRectangle pageSize = page.getMediaBox();
            float pageWidth = pageSize.getWidth();
            float pageHeight = pageSize.getHeight();
            PDPage firstPage = new PDPage(new PDRectangle(pageWidth, pageHeight));
            PDPageContentStream contentStream = new PDPageContentStream(document, firstPage, PDPageContentStream.AppendMode.APPEND, true, true);
            PDImageXObject image = PDImageXObject.createFromByteArray(document, pic, null);
            contentStream.drawImage(image, 0, 0, pageWidth, pageHeight);
            document.getPages().insertBefore(firstPage, page);
            contentStream.close();
            document.save("exportJava.pdf");
            document.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }*/

    }
}
